   //////////////////////////////////////////////
  //       ROOMBA NOTIFICATIONS WITH          //
 //             A WEMOS D1 mini              //
//           http://www.educ8s.tv           //
/////////////////////////////////////////////

#include <ESP8266WiFi.h>

const char* ssid     = "yourssid";      // SSID of local network
const char* password = "yourpassword";   // Password on network

WiFiClient client;
char servername[]="educ8s.com";  // remote server we will connect to

int hallSensorPin = D5;    
int ledPin = D3; 
int state = 0;   
int programState =  0; //   
int secondsAway =0;
String result;

   

void setup() {
  pinMode(hallSensorPin, INPUT);
  pinMode(ledPin, OUTPUT);

  Serial.begin(115200);
  Serial.println("Connecting");
   
  connectToWifi();
  Serial.println("Connected");

  if(programState==1)
  {
   if(RoombaIsAtHome())
   {
       programState = 2;
   }
  }
}

void loop(){
 delay(1000);
 
 if(secondsAway>10800)//Roomba is missing
 {
  String seconds = String(secondsAway);
  sendEmail(seconds);
  programState = 4;
  secondsAway=0;
 }
 checkIfRoombaIsAtHome();
 switch(programState)
 {
  case 2: blinkSlowly();break;
  case 3: turnLedOn();secondsAway++;break;
  case 4: turnLedOff();break;

  default:break;
 }
  Serial.println(secondsAway);

}

boolean RoombaIsAtHome()
{
  readMagnetState();
  if(state==0)
  {
    Serial.println("Roomba is at Home.");
    return true;
  }else
  {
    Serial.println("Roomba is away");
    return false;
  }
}

void readMagnetState()
{ 
  boolean state1 = false;
  boolean state2 = false;
  state1 = digitalRead(hallSensorPin);
  state2 = digitalRead(hallSensorPin);
  
  if(state1==state2)
  {
    state = state1; 
  }else
  {
      state = digitalRead(hallSensorPin);
  }
  
  delay(100);
  
}

void connectToWifi()
{
   WiFi.begin(ssid, password);

   while (WiFi.status() != WL_CONNECTED) {
    delay(100);
  }
  programState=1;
}

void blinkSlowly() //Roomba is at home and we are connected to the Internet
{
  digitalWrite(ledPin,HIGH);
  delay(200);
  digitalWrite(ledPin,LOW);
  delay(2000);
}

void checkIfRoombaIsAtHome()
{

 if(RoombaIsAtHome() && programState == 3)
 {
  if(RoombaIsAtHome()) //check again, is it a false alarm?
  {
  String seconds = String(secondsAway);
  sendEmail(seconds);
  programState = 2;
  secondsAway=0;
  }
  
 else if(RoombaIsAtHome() && programState == 4)
 {
  programState = 2;
  secondsAway=0;
  }
  
 }else if(!RoombaIsAtHome())
 {
  programState = 3; //Roomba is moving around
 }
}

void turnLedOn()
{
  digitalWrite(ledPin,HIGH);
}
void turnLedOff()
{
  digitalWrite(ledPin,LOW);
}
void sendEmail(String seconds)
{
  if (client.connect(servername, 80)) {  //starts client connection, checks for connection
    Serial.println("connected");
    client.println("GET /send_email.php?seconds="+seconds+" HTTP/1.1"); //Send data
    client.println("Host: educ8s.com");
    client.println("Connection: close");  //close 1.1 persistent connection  
    client.println(); //end of get request
  } 
  else {
    Serial.println("connection failed"); //error message if no client connect
    Serial.println();
  }

 while(client.connected() && !client.available()) delay(1); //waits for data
  while (client.connected() || client.available()) { //connected or data available
    char c = client.read(); //gets byte from ethernet buffer
      result = result+c;
    }

  client.stop(); //stop client
  Serial.println(result);
  
}

